//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  pCvɂR}hsƌʂ_CNg邽߂̃jbg
//
//  p@͂̃jbgtĂTvvOQ
//
//  Fusa
//  http://delfusa.main.jp/delfusafloor/opensource/delfusa_library_f.html
//  ɂR[hЂȌ`ɂč쐬
//  http://delfusa.main.jp/delfusafloor/opensource/first.shtml
//  FusaTNXł
//
//-----------------------------------------------------------------------------
//
//  2016N1012
//    E2010N0126񋟂Ăjbg啝ɏC
//    EjbgƃNXύX
//    ER[h̏V[PXăR[h₷
//    E[Jϐɂ͑SăvtBbNXƂLǉ
//    E߂lTmemoryStreamɂ(߂lTMemoryStreamƏʓ|)
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plCommandRedirect;

interface

uses
  SysUtils, Windows, Classes, Forms, Dialogs;

type
  TplCommandRedirect = class
  private
    FLoopProcessMessages: Boolean;
    function GrabStdOut(ACommandLine: string;
      AStream: TMemoryStream; AOutStream: TMemoryStream): Boolean;
    function GetStringFromStream(const Stream: TStream): String;
  public
    constructor Create;
    function GrabStdOutStream(CommandLine: string;
      AOutMemory: TMemoryStream): Boolean; virtual;
    function GrabStdOutText(CommandLine: string): String; overload;
    function GrabStdOutText(CommandLine: string; StdInput: TStrings):
      String; overload;
    property LoopProcessMessages: Boolean read FLoopProcessMessages
                                          write FLoopProcessMessages;
  end;

implementation

//-----------------------------------------------------------------------------
//  ۂɃR}hC̃R}hsă_CNg֐
//-----------------------------------------------------------------------------
function TplCommandRedirect.GrabStdOut(ACommandLine: string;
  AStream: TMemoryStream; AOutStream: TMemoryStream): Boolean;
const
  BUFFER_SIZE = 8192;
var
  LhStdInRead     : THandle;
  LhStdInWrite    : THandle;
  LhStdInWriteDup : THandle;
  LhStdOutRead    : THandle;
  LhStdOutWrite   : THandle;
  LhStdReadErr    : THandle;
  LhStdWriteErr   : THandle;
  LSecutityAttrib : TSecurityAttributes;
  LStartupInfo    : TStartupInfo;
  LProcessInfo    : TProcessInformation;
  LStreamBuffSize : DWord;
  LWriteSize      : Cardinal;
  LdwRet          : DWORD;
  LdwReadSize     : DWORD;
  LBuffStdIn      : array [0..BUFFER_SIZE - 1] of Byte;
  LBuffStdOut     : array [0..BUFFER_SIZE - 1] of Byte;
  LBuffStdErr@@ : array [0..BUFFER_SIZE - 1] of Byte;
begin
  Result := False;

  //
  LhStdInRead     := 0;
  LhStdInWrite    := 0;
  LhStdInWriteDup := 0;
  LhStdOutRead    := 0;
  LhStdOutWrite   := 0;
  LhStdReadErr    := 0;
  LhStdWriteErr   := 0;

  //TSecurityAttributesoݒ
  LSecutityAttrib.nLength              := SizeOf(TSecurityAttributes);
  LSecutityAttrib.bInheritHandle       := True;
  LSecutityAttrib.lpSecurityDescriptor := nil;

  //exitłnhClose邽߂try-finallygp
  try
    //StdIn(W)ppCv𐶐ănh擾
    if not CreatePipe(LhStdInRead,
                      LhStdInWrite,
                      @LSecutityAttrib,
                      BUFFER_SIZE) then begin
      //StdInppCvG[(KvȂG[\邢͊֐Ɉǉ)
      exit;
    end;

    //W͂̏(Write)pȂ悤ɂ
    //̂DuplicateHandleŌpȂ쐬
    //̏ȂƗ]ȃ_CNgʂ擾邱Ƃ
    DuplicateHandle(GetCurrentProcess,
                    LhStdInWrite,
                    GetCurrentProcess,
                    @LhStdInWriteDup,
                    0,
                    False,
                    DUPLICATE_SAME_ACCESS);
    //Write͕svȂ̂ŃN[Y
    CloseHandle(LhStdInWrite);

    //StdOut(Wo)pCv𐶐ănh擾
    if not CreatePipe(LhStdOutRead,
                      LhStdOutWrite,
                      @LSecutityAttrib,
                      BUFFER_SIZE) then begin
      //StdOut(Wo)ppCvG[
      exit;
    end;

    //StdError(WG[)ppCv𐶐ănh擾
    if not CreatePipe(LhStdReadErr,
                      LhStdWriteErr,
                      @LSecutityAttrib,
                      BUFFER_SIZE) then begin
      //StdError(WG[)ppCvG[
      exit;
    end;


    //CreateProcess֐p̈ݒ
    //SW_SHOWɂĂSTARTF_USESTDHANDLEStO鎞̓EBhE͕\Ȃ
    ZeroMemory(@LStartupInfo, SizeOf(TStartupInfo));
    ZeroMemory(@LProcessInfo, SizeOf(TProcessInformation));
    LStartupInfo.cb          := SizeOf(TStartupInfo);
    LStartupInfo.hStdInput   := LhStdInRead;
    LStartupInfo.hStdOutput  := LhStdOutWrite;
    LStartupInfo.hStdError   := LhStdWriteErr;
    LStartupInfo.dwFlags     := STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES;
    LStartupInfo.wShowWindow := SW_SHOWNORMAL;

    //nhClose邽߂try-finallygp
    try
      UniqueString(ACommandLine);
      if not CreateProcess(nil,
                           PChar(ACommandLine),
                           @LSecutityAttrib,
                           nil,
                           True,
                           CREATE_NO_WINDOW,
                           nil,
                           nil,
                           LStartupInfo,
                           LProcessInfo) then begin
        //CreateProcesss
        exit;
      end;

      //͑҂ɂȂ܂ő҂
      WaitForInputIdle(LProcessInfo.hProcess, 1000);
      LStreamBuffSize := BUFFER_SIZE;
      while LStreamBuffSize = BUFFER_SIZE do begin
        //W͂ɃR}h_CNgꍇ
        //ȗprcmd.exeɑ΂R}h̎s
        AStream.Position := 0;
        LStreamBuffSize := AStream.Read(LBuffStdIn, BUFFER_SIZE);
        WriteFile(LhStdInWriteDup, LBuffStdIn, LStreamBuffSize, LWriteSize, nil);
      end;
      //pCvւ݂̏Inh
      CloseHandle(LhStdInWriteDup);


      //Wo͂̃_CNgʂ擾
      //obt@̃TCYł΃[v1̂
      AOutStream.Clear;
      repeat
        //擾Ɏsꍇ,^COOK̎
        if FLoopProcessMessages then begin
          Application.ProcessMessages;
          Sleep(50);
        end;

        //Wo̓pCv̓e𒲂ׂăTCY1ȏȂǂݎ
        PeekNamedPipe(LhStdOutRead, nil, 0, nil, @LdwReadSize, nil);
        if (LdwReadSize > 0) then begin
          ReadFile(LhStdOutRead, LBuffStdOut, SizeOf(LBuffStdOut), LdwReadSize, nil);
          AOutStream.Write(LBuffStdOut, LdwReadSize);
        end;

        //lɕWG[e̎擾
        //G[͏LhStdOutRead̏o͂͂Ȃ̂Ń[v̓G[擾1̂
        PeekNamedPipe(LhStdReadErr, nil, 0, nil, @LdwReadSize, nil);
        if (LdwReadSize > 0) then begin
          ReadFile(LhStdReadErr, LBuffStdErr, SizeOf(LBuffStdErr), LdwReadSize, nil);
          AOutStream.Write(LBuffStdErr, LdwReadSize);
        end;

        LdwRet := WaitForSingleObject(LProcessInfo.hProcess, 0);
      until LdwRet = WAIT_OBJECT_0;

      Result := True;
    finally
      TerminateProcess(LProcessInfo.hProcess, 0);
      CloseHandle(LProcessInfo.hProcess);
      CloseHandle(LProcessInfo.hThread);
    end;
  finally
    if LhStdInRead <> 0   then CloseHandle(LhStdInRead);
    if LhStdOutRead <> 0  then CloseHandle(LhStdOutRead);
    if LhStdOutWrite <> 0 then CloseHandle(LhStdOutWrite);
    if LhStdReadErr <> 0  then CloseHandle(LhStdReadErr);
    if LhStdWriteErr <> 0 then CloseHandle(LhStdWriteErr);
  end;
end;

//-----------------------------------------------------------------------------
constructor TplCommandRedirect.Create;
begin
  FLoopProcessMessages := False;
end;

//-----------------------------------------------------------------------------
//  Unicode(Delphi2009ȍ~ɑΉ
//  擾R[hύXȂ悤RawByteStringŒ`ɓǂݍ
//  ̌㌋ʂ̕ɑ
//-----------------------------------------------------------------------------
function TplCommandRedirect.GetStringFromStream(const Stream: TStream): string;

//Delphi 2009ȍ~
{$IFDEF Unicode}
var
  LpBuffer   : Integer;
  LStrBuffer : RawByteString;
begin
  Stream.Read(LpBuffer, SizeOf(Integer));
  SetLength(LStrBuffer, LpBuffer);
  Stream.Position := 0;
  Stream.Read(Pointer(LStrBuffer)^, LpBuffer * SizeOf(Char));

  //UTF-16Ȃ̂ŃXXϊȂ̂ǂ
  //PɑƃRpC[jOf̂ŃLXg
  Result := UnicodeString(LStrBuffer);
end;

//Delphi 2007ȑO
{$ELSE}
begin
  SetLength(Result, Stream.Size);
  Stream.Position := 0;
  Stream.ReadBuffer(Result[1], Stream.Size);
end;
{$ENDIF}

//-----------------------------------------------------------------------------
//  O痘pJ֐@
//  o͐悾_CNgꍇ
//  ʂ𕶎Ŏ擾
//-----------------------------------------------------------------------------
function TplCommandRedirect.GrabStdOutText(CommandLine: string): string;
var
  LStreamIn  : TMemoryStream;
  LStreamOut : TMemoryStream;
begin
  Result := '';

  LStreamIn  := TMemoryStream.Create;
  LStreamOut := TMemoryStream.Create;
  try
    if GrabStdOut(CommandLine, LStreamIn, LStreamOut) then begin
      Result := GetStringFromStream(LStreamOut);
    end;
  finally
    FreeAndNil(LStreamOut);
    FreeAndNil(LStreamIn);
  end;
end;

//-----------------------------------------------------------------------------
//  O痘pJ֐@
//  ͂Əo͂_CNgꍇ
//  ʂ𕶎Ŏ擾
//-----------------------------------------------------------------------------
function TplCommandRedirect.GrabStdOutText(CommandLine: string;
  StdInput: TStrings): string;
var
  LStreamIn  : TMemoryStream;
  LStreamOut : TMemoryStream;
begin
  Result := '';

  LStreamIn  := TMemoryStream.Create;
  LStreamOut := TMemoryStream.Create;
  StdInput.SaveToStream(LStreamIn);
  try
    if GrabStdOut(CommandLine, LStreamIn, LStreamOut) then begin
      Result := GetStringFromStream(LStreamOut);
    end;
  finally
    FreeAndNil(LStreamOut);
    FreeAndNil(LStreamIn);
  end;
end;

//-----------------------------------------------------------------------------
//  O痘pJ֐@
//  R}h̎sʂƂďo͂_CNgꍇ
//  TMemoryStreamŎ擾
//  TMemoryStream̐Ɣj͌Ăяoōs
//-----------------------------------------------------------------------------
function TplCommandRedirect.GrabStdOutStream(CommandLine: string;
  AOutMemory: TMemoryStream): Boolean;
var
  LStreamIn : TMemoryStream;
begin
  LStreamIn := TMemoryStream.Create;
  try
    Result := GrabStdOut(CommandLine, LStreamIn, AOutMemory);
    AOutMemory.Position := 0;
  finally
    FreeAndNil(LStreamIn);
  end;
end;

end.
